import math
from tkinter import *

def drawClock(canvas, left, top, right, bottom): # draw clocks centered anywhere
	#(cx, cy, r) = (width/2, height/2, min(width, height)/3) 
	# line5 centers the clock at the center of the canvas
	# draw the clock (circle)
	width = (right - left)
	height = (bottom - top)
	r = min(width, height)/2
	cx = (left + right)/2
	cy = (top + bottom)/2

	canvas.create_oval(left, top, right, bottom, fill="yellow")
	# draw the numbers
	for hour in range(12): # for each hour 
		# figure out what the angle is for each hour

		# break up the entire circle into 12 parts
		# need to figure out the coordinates of the thing we are trying to draw

		hourAngle = math.pi/2 - (2*math.pi)*(hour/12)
		hourX = cx + 0.85*r*math.cos(hourAngle)
		hourY = cy - 0.85*r*math.sin(hourAngle)
		label = int(hour) # special case if hour == 0, show 12
		if(hour == 0):
			label = "12"
		canvas.create_text(hourX, hourY, text=label, font="Consolas 8")

def draw(canvas, winWidth, winHeight): # width and the height of the canvas
	# draw a grid of clocks
	width = 100 # how wide each clock is going to be 
	height = 100
	margin = 5
	for row in range(3):
		for col in range(4):
			# structure is going to be similar for most grid based problems
			# margin: whitespace we add its not edge of the canvas
			left = 100 + col*width + margin
			# left: 0th clock at (200, 50), 1st clock at (240, 50)
			right = left + width - margin
			top = 50 + row*height + margin
			bottom = top + height - margin
			drawClock(canvas, left, top, right, bottom)

def runDrawing(width=300, height=300):
    root = Tk()
    canvas = Canvas(root, width=width, height=height)
    canvas.pack()
    draw(canvas, width, height)
    root.mainloop()
    print("bye!")

runDrawing(600, 600)